function dxndt = bspline_temporal_gradient(xn, p)
%   Copyright (C) 2015 Javier Royuela del Val  <jroyval@lpi.tel.uva.es>
%                      Santiago Sanz Estébanez <ssanest@lpi.tel.uva.es>
%   Laboratorio de Procesado de Imagen, Universidad de Valladolid
%   www.lpi.tel.uva.es
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.


% Please note that xn are the transformed coordinates
% Periodic extension is assumed
    switch p
        case 1
            %dxndt = diff(xn(:,:,[1:end 1],:),1,3);
            %dxndt = cat(3,diff(xn,1,3), xn(:,:,1,:)-xn(:,:,end,:));
            % dxndt = diff(xn,1,3);
            dxndt = cat(3, xn(:,:,2,:)-xn(:,:,1,:), ...
                0.5*(xn(:,:,3:end,:)-xn(:,:,1:end-2,:)), ...
                xn(:,:,end,:)-xn(:,:,end-1,:));
        case 2
%             dxndt = diff(xn(:,:,[end 1:end 1],:),2,3);
            dxndt = diff(xn, 2, 3);
            dxndt = cat(3, .5*dxndt(:,:,1,:), dxndt, .5*dxndt(:,:,end,:));
%             dxndt = zeros(size(xn));
%             dxndt(:,:,1,:)     = xn(:,:,2,:)-2*xn(:,:,1,:)  +xn(:,:,end,:);
%             dxndt(:,:,2:end-1,:) = diff(xn,2,3);
%             dxndt(:,:,end,:)   = xn(:,:,1,:)-2*xn(:,:,end,:)+xn(:,:,end-1,:);
            
%             for i=2:size(xn,3)-1
%                 dxndt(:,:,i,:) = xn(:,:,i+1,:)-2*xn(:,:,i,:)-xn(:,:,i-1,:);
%             end
            
        otherwise
            fprintf(2,'error');
    end
end