function dVdT = gradiente_javi(dIdxT,IT, ts, X, reg_gradient)
% function dVdT = gradiente_javi(IT, ts, X, reg_gradient, dIdx)
%
%   Copyright (C) 2015 Javier Royuela del Val  <jroyval@lpi.tel.uva.es>
%                      Santiago Sanz Estébanez <ssanest@lpi.tel.uva.es>
%   Laboratorio de Procesado de Imagen, Universidad de Valladolid
%   www.lpi.tel.uva.es
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.


    sm = size(IT);
    L  = ndims(IT) - 1;
    N  = sm(end); 
    
    if L == 2
        % [dIdx(:,:,:,1), dIdx(:,:,:,2)] = gradient(IT);
        % Metric gradient with respect to intensity
        dVdI = reg_gradient(IT);
        % It is set to zero out of ROI
        dVdI = bsxfun(@times,dVdI,X);
        dVdx = bsxfun(@times,dVdI,dIdxT);

        % Spatial metric gradient

        v1 = ts.v1 - ts.v1(1) + 1;
        v2 = ts.v2 - ts.v2(1) + 1;
        n1 = ts.v1(1):ts.v1(end);
        n2 = ts.v2(1):ts.v2(end);

        BB = ts.BB;

        aux  = convn(dVdx(n2,n1,:,:),BB,'same');
        dVdT = aux(v2,v1,:,:);

    elseif L == 3
        [dIdx(:,:,:,:,1), dIdx(:,:,:,:,2), dIdx(:,:,:,:,3)] = gradient(IT);
        % Metric gradient with respect to intensity
        dVdI = reg_gradient(IT);
        % It is set to zero out of ROI
        dVdI = bsxfun(@times,dVdI,X);

        % Spatial metric gradient
        dVdx = bsxfun(@times,dVdI,dIdx);

        vx = ts.vx - ts.vx(1) + 1;
        vy = ts.vy - ts.vy(1) + 1;
        vz = ts.vz - ts.vz(1) + 1;

        BB = ts.BB;

        aux  = convn(dVdx,BB,'same');
        dVdT = aux(vy,vx,vz,:,:);
    else
        error('dim err');
    end

end

