function [  H, tiempo, Tout, IT, optout ] = gwreg_run( x, ts, T, I, X, parametros, Wn )
%function [ H, tiempo, T, IT, optout] = optimizadorcg_javi(x, ts, T, I, X, parametros, Wn)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
%
%   Copyright (C) 2015 Javier Royuela del Val  <jroyval@lpi.tel.uva.es>
%                      Santiago Sanz Estébanez <ssanest@lpi.tel.uva.es>
%   Laboratorio de Procesado de Imagen, Universidad de Valladolid
%   www.lpi.tel.uva.es
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.


pars.nvar = numel(T);
pars.fgname = 'fgtest';
pars.ts = ts;
pars.x = x;
pars.X = X;
pars.areaX = sum(X(:)>0);
pars.I = I;
pars.Wn = Wn;

pars.le = parametros.le;
pars.reg_metric = parametros.reg_metric;
pars.reg_gradient = parametros.reg_gradient;
pars.interpolation = parametros.interpolation;

pars.T_frames = size(T,3);

options.x0 = T(:);
options.nstart = 1;
options.maxit = 1000;
%options.normtol = 1e-2;
options.normtol = parametros.normtol;
options.fvalquit = -inf;
options.xnormquit = 1;
options.cpumax = inf;
options.version = 'C';
%           'P' for Polak-Ribiere-Polyak (not recommended: fails on hard problems)
%           'F' for Fletcher-Reeves (not recommended: often stagnates)
%           'C' for Polak-Ribiere-Polyak Constrained by Fletcher-Reeves 
%              (recommended, combines advantages of 'P' and 'F'; default)
%           'S' for Hestenes-Stiefel (not recommended)
%           'Y' for Dai-Yuan (allows weak Wolfe line search, see below)
%           'Z' for Hager-Zhang
%           '-' for Steepest Descent (for comparison)
options.strongwolfe = 1;
options.wolfe1 = 1e-4;
options.wolfe2 = 0.49;
options.prtlevel = 2;

% Just to remove persisent variables.
eval(['clear ' pars.fgname]);

ticid=tic;
[Tout, f, g, frec, alpharec] = nlcg(pars, options);
tiempo = toc(ticid);

H = f;
Tout = reshape(Tout,size(T));

xn = bspline_transform(x,ts,Tout);
IT = interpolar(x,xn,I,pars.interpolation,0);

optout.g = g;
optout.f = f;
optout.frec = frec;
optout.alpharec = alpharec; 
end


